package com.base.scanqr.ui.text

import android.content.ActivityNotFoundException
import android.content.Intent
import android.net.Uri
import android.os.Environment
import android.widget.Toast
import androidx.activity.addCallback
import androidx.core.view.updatePadding
import com.base.scanqr.R
import com.base.scanqr.ads.AdsMgr
import com.base.scanqr.ads.AdsShowCallBack
import com.base.scanqr.base.BaseActivity
import com.base.scanqr.bean.FunctionUIBean
import com.base.scanqr.bean.ScanBean
import com.base.scanqr.bean.TextUIBean
import com.base.scanqr.databinding.ActivityTextCodeBinding
import com.base.scanqr.ui.widget.InputNameDialog.showInputNameDialog
import com.base.scanqr.utils.BarUtils
import com.base.scanqr.utils.BitmapUtils.saveBitmapToFile
import com.base.scanqr.utils.ClipboardUtils.copyText
import com.base.scanqr.utils.IntentUtils.intentShareText
import com.base.scanqr.utils.LogEx
import com.base.scanqr.utils.QRCodeUtils.generateQRCode
import com.base.scanqr.utils.SpJsonUtils
import com.base.scanqr.utils.ToastUtils.toast
import com.google.gson.Gson
import java.io.File


class TextCodeActivity : BaseActivity<ActivityTextCodeBinding>(ActivityTextCodeBinding::inflate) {

    private var textUIBean = TextUIBean()
    private var tempImage: String = ""

    override fun onResumeOneShoot() {
        super.onResumeOneShoot()
        val flag = changeLanguage()
        if (flag) return

        AdsMgr.showBanner(binding.flBanner, false)
    }

    override fun initView() {
        super.initView()
        binding.clTop.updatePadding(top = BarUtils.getStatusBarHeight())
        AdsMgr.showNative(binding.flAd, R.layout.layout_admob_item)

        val data = intent.extras?.getString("data")
        data?.let {
            textUIBean = Gson().fromJson(data, TextUIBean::class.java)
            binding.tvContent.text = textUIBean.content
        }
        Thread {
            val bitmap = generateQRCode(textUIBean.content, 735, 735, 5)
            runOnUiThread {
                binding.ivQr.setImageBitmap(bitmap)
                val file = File(cacheDir, System.currentTimeMillis().toString() + ".jpg")
                bitmap?.let {
                    val flag = saveBitmapToFile(it, file.absolutePath)
                    LogEx.logDebug(TAG, "flag=$flag tempImage=${file.absolutePath}")
                    if (flag) {
                        tempImage = file.absolutePath
                    }
                }
                if (textUIBean.needCreate) {
                    textUIBean.needCreate = false
                    SpJsonUtils.addJsonBean<TextUIBean>(FunctionUIBean.KEY_TEXT, textUIBean)
                }
            }
        }.start()
    }

    override fun initListener() {
        super.initListener()
        onBackPressedDispatcher.addCallback {
            AdsMgr.showInsert(this@TextCodeActivity, false, object : AdsShowCallBack() {
                override fun close(where: Int) {
                    finishToMainTop()
                }

                override fun failed(where: Int) {
                    finishToMainTop()
                }

                override fun googleFailed(where: Int) {
                    finishToMainTop()
                }
            })
        }
        binding.flBack.setOnClickListener {
            onBackPressedDispatcher.onBackPressed()
        }
        binding.llShare.setOnClickListener {
            val intent = intentShareText(textUIBean.content)
            runCatching {
                startActivity(intent)
            }
        }
        binding.llPdf.setOnClickListener {
            toast("没实现")
        }
        binding.llDownload.setOnClickListener {
            kotlin.runCatching {
                val appFile = File(
                    Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS),
                    this.resources.getString(R.string.app_name)
                )
                if (!appFile.exists()) appFile.mkdirs()
                var newName = File(tempImage).name
                showInputNameDialog(newName) { name ->
                    if (name.endsWith(".jpg")) {
                        name.also { newName = it }
                    } else {
                        newName = "$name.jpg"
                    }
                    val downFile = File(appFile, newName)
                    downFile.createNewFile()
                    File(tempImage).copyTo(downFile, true)
                    toast("Save to:${appFile.absolutePath}", true)
                }
            }
        }
        binding.llCopy.setOnClickListener {
            copyText(TAG, textUIBean.content)
            toast("Copied to clipboard", true)
        }
        binding.flSearch.setOnClickListener {

            val intent = Intent(Intent.ACTION_VIEW)
            intent.setData(Uri.parse("https://www.google.com/search?q=${textUIBean.content}"))

            try {
                startActivity(intent)
            } catch (e: ActivityNotFoundException) {
                toast("")
                Toast.makeText(this, "No application was found to handle the search request", Toast.LENGTH_SHORT).show()
            }
        }
    }


}